#import <appkit/appkit.h>
#import "InfoItemListener.h"
#import <mach.h>
#import <sys/message.h>
#import <servers/netname.h>
extern port_t name_server_port;
extern id NXResponsibleDelegate();
@implementation  InfoItemListener :Listener
{}
static NXRemoteMethod *remoteMethods = NULL;
#define REMOTEMETHODS 4
+ (void)initialize 
/* */
{
    if (!remoteMethods) {
	remoteMethods =
	(NXRemoteMethod *) malloc((REMOTEMETHODS+1)*sizeof(NXRemoteMethod));
	remoteMethods[0].key = 
	@selector(giveInfoItemNamed:string:);
	remoteMethods[0].types = "cc";
	remoteMethods[1].key = 
	@selector(giveInfoItemNamed:data:length:);
	remoteMethods[1].types = "cb";
	remoteMethods[2].key = 
	@selector(getInfoNamed:string:);
	remoteMethods[2].types = "cC";
	remoteMethods[3].key = 
	@selector(getInfoNamed:data:length:);
	remoteMethods[3].types = "cB";
	remoteMethods[REMOTEMETHODS].key = NULL;
    }
}
-(int)giveInfoItemNamed : (char *) name
	string : (char *) string
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(giveInfoItemNamed:string:)))
	return [_NXd giveInfoItemNamed : name
		string : string];
    return -1;
}

-(int)giveInfoItemNamed : (char *) name
	data : (char *) data
	length : (int) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(giveInfoItemNamed:data:length:)))
	return [_NXd giveInfoItemNamed : name
		data : data
		length : len];
    return -1;
}

-(int)getInfoNamed : (char *) name
	string : (char **) string
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(getInfoNamed:string:)))
	return [_NXd getInfoNamed : name
		string : string];
    return -1;
}

-(int)getInfoNamed : (char *) name
	data : (char **) data
	length : (int *) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(getInfoNamed:data:length:)))
	return [_NXd getInfoNamed : name
		data : data
		length : len];
    return -1;
}

- (int) performRemoteMethod : (NXRemoteMethod *) method
                  paramList : (NXParamValue *) paramList {
/* */
    switch (method - remoteMethods) {
    case 0:
	return [self giveInfoItemNamed : paramList[0].bval.p
		string : paramList[1].bval.p];
    case 1:
	return [self giveInfoItemNamed : paramList[0].bval.p
		data : paramList[1].bval.p
		length : paramList[1].bval.len];
    case 2:
	return [self getInfoNamed : paramList[0].bval.p
		string : &paramList[1].bval.p];
    case 3:
	return [self getInfoNamed : paramList[0].bval.p
		data : &paramList[1].bval.p
		length : &paramList[1].bval.len];
    default:
	return [super performRemoteMethod : method paramList : paramList];
    }
}
- (NXRemoteMethod *) remoteMethodFor: (SEL) aSel {
/* */
    NXRemoteMethod *rm;
    if (rm = NXRemoteMethodFromSel(aSel,remoteMethods))
        return rm;
    return [super remoteMethodFor : aSel];
}
@end
