//Copyright 1992 Intuitive Edge All Rights Reserved
//AppDelegate.h
/* AppDelegate is a textLab type of application that works in conjunction with 
a GenericDocument.  Together they cover the basic functionality of a document
based application including :

Info...
Help... (system 2.0 style)
Preferences...

Open
New
Save (in GenericDoc)
SaveAs... (in GenericDoc)
Revert to Saved (in GenericDoc)
Save All
Close (in GenericDoc)

To use do a search/replace on GenericDocument,genericDoc, AppVersion and extension
most of this stuff was adapted from OS release 2.0 Examples/Draw
*/

#import <appkit/Responder.h>

@interface AppDelegate:Responder
{
	id infoPanel;
	id version;	//the version field of the info panel: IB outlet
	id helpPanel;
	id helpScrollView;//outlet
	id helpText;
	id prefObject;
	BOOL haveOpenedDocument;
}

+initialize;

- currentDocument;
- (const char *)currentDirectory;

/* Shared panels */
- saveAsPanel;

/* Target/Action methods */
- help:sender;
- info:sender;
- preferences:sender;
- new:sender;
- open:sender;
- saveAll:sender;


/*app delegate methods for initializing, opening from workspace, and updating menu Items */
- appWillTerminate:sender;
- appDidInit:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;
- (BOOL)menuItemUpdate:menuCell;
- (BOOL)validateCommand:menuCell;

/*housekeeping functions */
extern void initMenu(id menu);
extern id documentInWindow(id window);
extern id findDocument(const char *name);
extern id openFile(const char *directory, const char *name, BOOL display);

@end